# !/usr/bin/env python
# -*- coding: cp1252 -*-

'''
Pregunta 1
'''

# A)
'''
>>> Control1 = 5.5
>>> Control2 = 4.1
>>> Control3 = 6.4
>>> Promedio = control1 + control2 + control3/total
Traceback (most recent call last):
  File "<input>", line 1, in <module>
NameError: name 'control1' is not defined

Ac nos arroj un error de Nombre, es decir que una variable no fue definida previamente
intent ser accedida. En este caso, hay que tener en cuenta que las maysculas son
distintivas en las variables, por lo que "control1" es distinto a "Control1".
Para arreglarlo, hay que cambiar las variables involucradas a minusculas, o la primera
letra mayuscula.

Luego, aparecer el siguiente error:
NameError: name 'total' is not defined
debido a que la variable total no est definida en ningun lado. Para arreglarlo, podemos
definir la variable total antes de hacer el calculo final, o bien, eliminar esa referencia
y colocar directamente el valor en la divisin ( /3).

Finalmente, hay un error ms grave an y dificil de detectar a veces, y es que
Python respeta el orden de las operaciones, por lo que al no existir un parntesis,
se asume que la divisin nicamente afectar al control3. Reescrita con
parntesis vemos que ...

- Lo que queremos es: (control1 + control2 + control3) / 3.0
- Lo que en verdad hace es: control1 + control2 + (control3 / 3.0)

Por lo que para arreglarlo, tenemos que colocar los parentesis adecuados para realizar
bien la operacin.
'''

# ---------------------------------------------
# B)
'''
>>> di stancia = 20000.0                        # metros
>>> tiempo = 3000                               # segundos
>>> v = (distancia / 1000) / (tiempo / 3600)    # velocidad en km/h

El primer error, es que al escribir la primera linea, arroja el error:
SyntaxError: invalid syntax.
Esto debido a que la variable "di stancia" tiene un espacio entremedio,
lo cual no es la forma correcta de definir variables (estas no pueden contener espacios)
Para arreglarlo basta con borrar el espacio.

Otro error, y muy frecuente, es el que ocurre en este caso al calcular el resultado
final. Aparntemente, la frmula est correcta y de hecho, los valores numricos
para la conversin estn bien. El error radica en el uso de la divisin entera en Python.

Veamos que la distancia se defini como 20000.0 (Float), por lo que al dividir
por Int o Float, nos dar Float. Sin embargo, el tiempo fue definido como 3000 (Int),
por lo que al dividirlo por otro entero, Python realizar la divisin entera de dichos
nmeros. En particular en este ejemplo, se cae en dicho caso, debido a que se hace la
divisin entre 3000 y 3600, lo cual da 0, y por consiguiente, ser arrojado el error
de divisin por 0.

Una forma fcil de recordar dichos comportamientos, es pensar que Float domina por
sobre Int, por lo que basta que exista un Float en una operacin como suma, resta,
multiplicacin o divisin, para que el resultado sea Float.
De esta forma, es fcil ver que para que un resultado sea entero,
es que ambos operandos sean enteros.

Ahora respecto a como solucionar el problema: Existen varias alternativas, por ejemplo
definir la variable tiempo como 3000.0, o bien dividir tiempo por 3600.0 o bien
multiplicar tiempo por 1.0 antes de realizar la divisin.
Hay que tener cuidado con colocar lo siguiente: float(3000/3600), 
ya que lo primero que se har, es la divisin entera, que ya sabemos nos da 0,
y posteriormente, transforma dicho nmero a un Float, por lo que terminamos con un 0.0.
La moraleja entonces es asegurarse que ANTES de efectuar la divisin exista al menos
un Float en los operandos. 
'''

# ---------------------------------------------
# C)
'''
>>> mascota = 'perritos'
>>> cantidad = 10
>>> mensaje = Yo tenia + cantidad + mascota

Primero, arroja el siguiente error al intresar la tercera linea:

SyntaxError: invalid syntax

Esto, debido a que la primera parte del mensaje, Yo y tenia, es un mensaje que no fue
colocado entre comillas, por lo que python en vez de interpretarlo como texto, intenta
buscar variables con esos nombres (las cuales no existen), y ademas no hay un operador
entre ambas, por lo que arroja error de sintaxis, pues las variables se relacionan
entre si mediante operaciones. Para arreglarlo, hay que colocarle comillas a 'Yo tenia',
para que lo interprete como texto.

Luego, el segundo error que arroja es el siguiente:

TypeError: cannot concatenate 'str' and 'int' objects

Esto, debido a que no podemos concatenar directamente dos datos que sean
de tipos distintos (en este caso texto/string (la mascota) y numerico (la cantidad))
Para remediarlo, tenemos que convertir el numero a texto, con la funcin str()
>>> mensaje = 'Yo tenia' + str(cantidad) + mascota

Finalmente, una vez creado el mensaje, notamos que hay un pequeo error/detalle, ya
que todos los elementos del texto se encuentran juntos: 'Yo tenia10perritos', esto debido
a que si queremos agregar espacios u otros elementos, tenemos que especificarlo
explicitamente. Por lo que, para arreglarlo, haremos eso:
>>> mensaje = 'Yo tenia ' + str(cantidad) + ' ' + mascota
(el espacio vacio entre comillas, representa un espacio textual)
'''

# ---------------------------------------------
# D)

'''
>>> terremoto = '1000'
>>> cantidad = '3'
>>> costo = terremoto * cantidad

Traceback (most recent call last):
  File "<input>", line 1, in <module>
TypeError: can't multiply sequence by non-int of type 'str'

Notemos que nos arroja error de la categora "Error de tipo". sto significa que estamos
realizando una operacin de elementos que no admiten los tipos entregados. En este caso,
estamos intentando multiplicar dos string, lo cual noesta definido, ya que la operacin
de multiplicacin espera argumentos de tipo numrico, o bien, un argumento de tipo numerico
y otro de texto.

Para arreglarlo, le podemos quitar las comillas a los numeros definidos en las variables
del principio, o bien, convertir a numero las variables terremoto y cantidad (con ayuda
de la funcin int()) durante el calculo de costo.
'''

# ---------------------------------------------
# E)

'''
>>> h=3
>>> def jalisco(h):
        h = h+1
        return h
>>> jalisco(5)       # cual es el resultado que entrega jalisco?  
>>> h                # cual ser el valor de la variable h definida al principio?

Primero notemos que la funcin jalisco, simplemente toma un numero h cualquiera, le suma 1,
y luego devuelve como resultado el numero h recibido, pero incrementado en 1.
Esta pregunta apunta directamente a lo que se conoce como "alcance" de una variable.
El concepto que se debe tener claro es que una funcin define sus propias variables,
y ellas nacen y viven nicamente dentro de dicha funcin. En nuestro caso, primero
definimos una variable h, que contendr el valor 3.
Posteriormente se define una funcin que recibe como parmetro un valor,
que se almacenar en una variable tambin llamada h.
Pero aqu est lo importante, y es que ambas variables son distintas!
La variable h de la funcin jalisco, slo vive dentro de su definicin y por ende
es distinta a la variable h=3 definida fuera de la funcin.

Otra forma de verlo es que las funciones generan una burbuja totalmente independiente
del resto del programa (y por lo tanto de otras funciones tambin), en la que pueden
crear variables nuevas que viven nicamente dentro de dicha burbuja, y no les importa
si existe  alguna variable fuera de ella con el mismo nombre. En resumen, todas las
variables que se crean dentro de una funcin nacen, viven y mueren dentro de la funcin
(lo unico que se salva, por ahora, es el valor de retorno de la funcin)

Habiendo logrado entender lo anterior, veamos cules sern los resultados finales. 

1) Primero se llama a jalisco con el valor 5, por lo que la variable h de la
   funcin ser reemplazada por dicho valor, y no la que definimos antes como 3.
   (Recordemos la burbuja, la variable h de la funcin slo acta dentro de
    sus instrucciones de definicin)
   
2) La funcin reescribe su variable h, como el valor que tiene mas uno, es decir 6,
   y finalmente retorna el h actualizado. Luego, lo que entrega jalisco, es 6.
   
3) Ahora bien cuando se pregunta por h, estamos fuera de la burbuja, por lo que el
   nico h que conocemos, es el que definimos justo antes de definir la funcin.
   Luego, el valor final de dicho h sigue siendo 3, ya que no existe ninguna instruccin
   que redefina h fuera de la burbuja generada por jalisco.
   
'''





